<template>
  <FormControl
    :id="id"
    :label="label"
    :required="required"
    :error="error"
    class="textarea-wrapper"
  >
    <textarea
      v-show="!isPreview"
      :id="id"
      :name="id"
      :type="type"
      :placeholder="placeholder"
      :required="required"
      :value="value"
      @input="$emit('update', $event.target.value)"
      :class="size"
    />
    <Paragraph v-if="isPreview" :text="value" class="preview-text" />
  </FormControl>
</template>

<script>
import FormControl from "./FormControl";
import { isPreviewMixin } from "../../mixins/isPreview";
import Paragraph from "../Paragraph";
export default {
  name: "FormTextarea",
  components: { Paragraph, FormControl },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String,
      required: true
    },
    value: {
      type: String,
      required: true
    },
    type: {
      type: String,
      default: "text"
    },
    label: String,
    error: String,
    size: {
      type: String,
      default: ""
    },
    placeholder: {
      type: String,
      default: "Details"
    },
    required: {
      type: Boolean,
      default: true
    }
  },
  model: {
    prop: "value",
    event: "update"
  }
};
</script>

<style lang="scss">
.textarea-wrapper {
  @include breakpoint(overPhone) {
    padding: 0 5rem;
  }
  textarea {
    &.big {
      height: 19rem;

      @include breakpoint(overPhone) {
        height: 21.1rem;
      }
    }
  }
}
</style>
